> ## Documentation Index
> Fetch the complete documentation index at: https://developers.hubspot.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Marketing API | Single send API

> An overview of the marketing single-send API in HubSpot.

> **[Postman collection](https://app.getpostman.com/run-collection/26126890-a562dddd-ea78-4e00-867e-03cecae5a983)**

> **Scope requirements**

The single-send API allows you to send template emails created in the HubSpot [marketing email tool](https://knowledge.hubspot.com/marketing-email/create-and-send-marketing-emails) using a JSON-formatted `POST` request.

All contacts receiving marketing content must be [set as marketing](https://knowledge.hubspot.com/records/set-contacts-as-marketing). Any marketing emails sent through the single-send API will automatically be associated with contact records based on their email address, and update non-marketing contacts and set them to marketing contacts. If there's no contact with a matching email address, a new contact record with that email will be created, and the contact will be set as marketing.

## Requirements

To use the marketing single send API, the following requirements must be met:

* You must have a ***Marketing Hub** Enterprise* account.
* The [app](https://developers.hubspot.com/docs/apps/developer-platform/build-apps/create-an-app.md) you're using to make API requests has been granted the `marketing-email` scope.

## Create an email and send it via the single-send API

First, [set up your email in HubSpot](https://knowledge.hubspot.com/marketing-email/send-transactional-emails). After you create the email, you can set the recipient details, including any contact or custom properties set up in the email template, in the body of the API request. Before you can make the API request, you'll need the ID of the email:

* If you leave the email drafted without publishing it, you can get the email ID from the URL when you're in the email editor. The ID is the final numeric value before the final slash character (`/`) in the URL (e.g., `https://app.hubspot.com/email/{PORTAL_ID}/edit/{EMAIL_ID}/settings`).

![email-id-for-drafted-single-send-api-email](https://www.hubspot.com/hubfs/Knowledge_Base_2023/email-id-for-drafted-single-send-api-email.png)

* If you publish your email, you can copy the email ID from the email details page.

![Screen Shot 2020-04-15 at 1.00.37 PM](https://cdn2.hubspot.net/hubfs/53/Screen%20Shot%202020-04-15%20at%201.00.37%20PM.png)

> [!WARNING]
>
> **Please note:**
>
> HubSpot does not save the HTML/JSON sent through this API. You can review the email template from the recipient contact's timeline, but if you want to keep a record of the email's contents, it's recommended to add a BCC to the email.

To send an email with the Single-Send API, make a `POST` request to `/marketing/email-campaigns/2026-09/single-send`.

### Request properties

The request body must be a JSON-formatted object with the following properties:

| Property | Type | Description |
| - | - | - |
| `emailId` required | Integer | The email's content ID, which can be found in HubSpot's email tool, as described [above](#create-an-email-and-send-it-via-the-single-send-api). |
| `message` | Object | The message field is an object containing anything that you want to override. At the minimum, you must include the `to` field. See more details in the [section below](#message). |
| `contactProperties` | Object | An object with any dynamic contact properties that will be included as part of the email personalization. See more details in the [section below](#contactProperties). |
| `customProperties` | Object | An object of property values that relate to any other dynamic properties in the email, detailed in the [section below](#customProperties). |

#### message

The message field is a JSON object containing email metadata. The available fields are provided in the table below:

| Field | Type | Description |
| - | - | - |
| `to` required | String | The recipient of the email |
| `from` | String | The "From" header for the email. You can define a from name with the following format:  `"from":"Sender Name <sender@hubspot.com>"` |
| `sendId` | String | The ID of a particular send. Only one email with a given `sendId` will be sent per account, so you can include this field to prevent duplicate email sends. |
| `replyTo` | Array | An array of "Reply-To" header values for the email. |
| `cc` | Array | An array of email addresses to send as CC. |
| `bcc` | Array | An array of email addresses to send as BCC. |

#### contactProperties

The `contactProperties` field is a JSON object of contact property values. Each contact property value contains a `name` and `value`. Each property will be set on the contact record and will be visible in the template under:

![name-token-in-template-for-transactional-email](https://www.hubspot.com/hubfs/Knowledge_Base_2021/Developer/name-token-in-template-for-transactional-email.png)

Use these properties when you want to set a contact property while you’re sending the email. For example, when sending a receipt you may want to set a `last_paid_date` property, as the sending of the receipt will have information about the last payment.

```json theme={null}
{
  "emailId": 4126643121,
  "message": {
    "to": "jdoe@hubspot.com",
    "sendId": "6"
  },
  "contactProperties": {
    "last_paid_date": "2022-03-01",
    "firstname": "jane"
  }
}
```

#### customProperties

The `customProperties` field is a JSON object of key-value properties. These properties are generally related to the email itself, not the contact receiving the email. They will not appear in the [web page version of the email](https://knowledge.hubspot.com/marketing-email/create-a-web-version-of-your-marketing-email), or in the view of the email from the contact's timeline. These properties are also not stored in HubSpot and will only be included in the sent email.

Each key in the `customProperties` field can be referenced in the template using a [HubL expression](https://developers.hubspot.com/docs/cms/reference/hubl/overview.md) for fields contained within the `custom` variable (e.g., `{{ custom.NAME_OF_PROPERTY }}` ).

For example, if your email template references two properties, `purchaseUrl` and `productName`, you could provide the associated values for these properties with the following request body:

```json theme={null}
{
  "emailId": 4126643121,
  "message": {
    "to": "jdoe@hubspot.com",
    "sendId": "6"
  },
  "customProperties": {
    "purchaseUrl": "https://example.com/link-to-product",
    "productName": "vanilla"
  }
}
```

You can then reference these properties in your email template:

```hubl theme={null}
<!doctype html>
<html>
  <p>
    Congrats on purchasing some of the best ice cream around.
  </p>
  <a href={{custom.purchaseUrl}}>{{custom.productName}}</a>
</html>
```

The `customProperties` field only supports arrays when used with [programmable email content](https://developers.hubspot.com/docs/cms/start-building/features/data-driven-content/emails-with-programmable-content.md). In your email template, you can reference the items defined in your `customProperties` field by using a [HubL expression](https://developers.hubspot.com/docs/cms/reference/hubl/overview.md) (e.g., using a [for loop](https://developers.hubspot.com/docs/cms/reference/hubl/loops.md) to render each item in a list). For example, if the `customProperties` you included in your request body was structured like the following JSON snippet below:

```json theme={null}
{
  "emailId": 4126643122,
  "message": {
    "to": "jdoe@hubspot.com",
    "sendId": "7"
  },
  "customProperties": {
    "exampleArray": [
      { "firstKey": "someValue", "secondKey": "anotherValue" },
      { "firstKey": "value1", "secondKey": "value2" }
    ]
  }
}
```

You could then reference the values for each item in `exampleArray` with the following HubL code:

```hubl theme={null}
<!doctype html>
<html>
  <p>
    Thanks for your recent purchase! Here are the details of the items you'll be receiving:
  </p>
  <ul>
    {% for item in custom.exampleArray %}
      <li>First key: {{ item.firstKey }}, Second key: {{item.secondKey}}</li>
    {% endfor %}
  </ul>
</html>
```

Once sent, the email would render the contents of the associated programmable email template as follows:

![example-transactional-email-with-customProperties-array](https://www.hubspot.com/hubfs/Knowledge_Base_2021/Developer/example-transactional-email-with-customProperties-array.png)

### Response

The response contains the following fields:

| Field | Type | Description |
| - | - | - |
| `sendResult` | String | An enumeration that represents the email's send status. The possible values are [listed below](#sendresult-values). |
| `requestedAt` | String | An ISO 8601 formatted timestamp from when the send was requested. |
| `startedAt` | String | An ISO 8601 formatted timestamp from when the send began processing. |
| `message` | String | A supplementary message describing the result. |
| `completedAt` | String | An ISO 8601 formatted timestamp when the send completed. |
| `statusId` | String | An identifier that can be used to [query the status of the send](#query-the-status-of-an-email-send). |
| `status` | String | The status of the send request. Possible values are: `PENDING`, `PROCESSING`, `CANCELED`, and `COMPLETE`. |
| `eventId` | Object | If sent in the original request, this object will be included in the response, which includes two fields: <ul><li>`id`: the ID of the sent event.</li><li>`created`: an ISO 8601 formatted timestamp of the sent event</li></ul>. |

### Query the status of an email send

To get the status of the email send, make a `GET` request to `https://api.hubapi.com/marketing/v3/email/send-statuses/{statusId}`.

The response contains the following fields:

| Field | Type | Description |
| - | - | - |
| `sendResult` | String | An enumeration that represents the email's send status. The possible values are [listed below](#sendresult-values). |
| `requestedAt` | String | An ISO 8601 formatted timestamp from when the send was requested. |
| `startedAt` | String | An ISO 8601 formatted timestamp from when the send began processing. |
| `completedAt` | String | An ISO 8601 formatted timestamp timestamp when the send completed. |
| `statusId` | String | An identifier that can be used to query the status of the send. |
| `status` | String | The status of the send request. Possible values are: `PENDING`, `PROCESSING`, `CANCELED`, and `COMPLETE`. |
| `eventId` | Object | If sent in the original request, this object will be included in the response, which includes two fields: <ul><li>`id`: the ID of the sent event.</li><li>`created`: an ISO 8601 formatted timestamp of the sent event</li></ul>. |

### sendResult values

The `sendResult` is an enumeration that reflects the result of an email send attempt, either in the initial response or when querying for the status of an email send after your initial request.

Its possible values are:

| Value | Description |
| - | - |
| `SENT` | The email was sent successfully. |
| `QUEUED` | The email was queued and will send as the queue gets processed. |
| `PORTAL_SUSPENDED` | Due to [Acceptable Use Policy](https://legal.hubspot.com/acceptable-use) violations, the HubSpot customer's email has been suspended. |
| `INVALID_TO_ADDRESS` | The recipient address is invalid. This error will also occur if you attempt to send an email with any of the following role-based prefixes in the email address: `abuse`, `no-reply`, `noreply`, `root`, `spam`, `security`, `undisclosed-recipients`, `unsubscribe`, `inoc`, `postmaster`, or `privacy`. |
| `BLOCKED_DOMAIN` | The domain cannot receive emails from HubSpot at this time. |
| `PREVIOUSLY_BOUNCED` | The recipient has previously bounced, and the sending logic resulted in no send. |
| `PREVIOUS_SPAM` | The recipient has previously marked similar email as spam. |
| `INVALID_FROM_ADDRESS` | The *From* address is invalid. |
| `MISSING_CONTENT` | The `emailId` is invalid, or the `emailId` corresponds to an email that wasn't set up for Single-Send. |
| `MISSING_TEMPLATE_PROPERTIES` | There are properties set up in the template that have not been included in the `customProperties` sent in the request. |
